def collatz_sequence(n):
    sequence = [n]
    while n > 1:
        if n % 2 == 0:
            n //= 2
        else:
            n = 3*n + 1
        sequence += [n]
    return sequence

def euler_14():
    max_len = start_num = 0
    for i in range(10_000):
        l = len(collatz_sequence(i))
        if l > max_len:
            max_len, start_num = l, i
    return start_num
